
unit inifile;

interface

type
     string127 = string[127];

procedure getinistring(var inifile : text; name : string127; var value : string127);
procedure getconfig(configfile : string; var value:array of string127);


implementation


     procedure getinistring;
     var
          buf                 : string127;
          i, j                : byte;
     begin
          value := '';
          reset(inifile);
          while not seekeof(inifile) do
               begin
                    readln(inifile, buf);
                    if ((buf[1] <> ';') and (buf[1] <> '%')) then
                         begin
                              i := 1;
                              while (buf[i] = ' ') or (buf[i] = #9) do inc(i);
                              if (pos(name, buf) = i) then
                                   begin
                                        i := i+length(name);
                                        while (buf[i] = ' ') or (buf[i] = #9) do inc(i);
                                        j := 1;
                                        while ((buf[i+j] <> ';') and (buf[i+j] <> '%'))
                                        and (j < ord(buf[0])-i+1) do inc(j);
                                        value := copy(buf, i, j);
                                        exit;
                                   end;
                         end;
               end;
     end;


     procedure getconfig;
     var
          config              : text;
          i                   : integer;
          buf                 : pointer;
     begin
          i := ioresult;
          assign(config, configfile);
          getmem(buf, 5120);
          settextbuf(config, buf^, 5120);
          reset(config);
          i := ioresult;
          if i <> 0 then
               begin
                    writeln('Error reading file:  ', configfile);
                    writeln('Program aborted');
                    halt(20);
               end;
          for i := low(value) to high(value) do getinistring(config, value[i], value[i]);
          close(config);
          freemem(buf, 5120);
     end;


end.